function  [particelle,celle,jxoutl,jxoutr]=trasporta(celle,u,particelle1,xb,dt)
%
% Calcola il passo di convezione, cioe' ridistribuisce le
% particelle nelle celle, secondo le loro velocita' microscopiche
%
% Move particles:
particelle(:,1) = particelle1(:,1) + particelle1(:,2)*dt;
particelle(:,2) = particelle1(:,2);
% Re-distribute particles in cells
n=length(celle);
clear celle
for j=1:n
   clear jx
   jx=find(particelle(:,1)>xb(j) & particelle(:,1) <= xb(j+1));
   celle(j).i=[jx'];
   celle(j).number=length(jx);
end
% Periodic boundary conditions
% particles exiting from the left
jxoutl=find(particelle(:,1)<xb(1));
celle(n).number=celle(n).number+length(jxoutl);
celle(n).i=[celle(n).i, jxoutl'];
particelle(jxoutl,1)=particelle(jxoutl,1)+xb(n+1)-xb(1);
jxoutr=find(particelle(:,1)>=xb(n+1));
celle(1).number=celle(1).number+length(jxoutr);
celle(1).i=[celle(1).i, jxoutr'];
particelle(jxoutr,1)=particelle(jxoutr,1)-(xb(n+1)-xb(1));
